// ignore_for_file: avoid_print, no_leading_underscores_for_local_identifiers

library tencent_cloud_chat_vote_plugin;

import 'dart:convert';

import 'package:tencent_cloud_chat_vote_plugin/config/tencent_cloud_chat_vote_config.dart';
import 'package:tencent_im_base/tencent_im_base.dart';

export 'package:tencent_cloud_chat_vote_plugin/components/vote_create/vote_create.dart';
export 'package:tencent_cloud_chat_vote_plugin/components/vote_detail/vote_detail.dart';
export 'package:tencent_cloud_chat_vote_plugin/components/vote_message/vote_message.dart';
export 'package:tencent_cloud_chat_vote_plugin/struct/vote_custom_struct.dart';
export 'package:tencent_cloud_chat_vote_plugin/config/tencent_cloud_chat_vote_config.dart';

/// TencentCloudChatVotePlugin.
class TencentCloudChatVotePlugin {
  static final V2TIMManager imManager = TencentImSDKPlugin.v2TIMManager;

  // static TencentCloudChatVoteConfig? _config;

  static late String currentUser;
  static bool hasInited = false;

  static initPlugin({
    TencentCloudChatVoteConfig? config,
  }) async {
    if (config != null) {
      // _config = config;
    }
    String _currentUser = await _getCurrentLoginUser();
    if (_currentUser.isNotEmpty) {
      currentUser = _currentUser;
      hasInited = true;
    } else {
      print(
        "Very important message: Failed to initialize Tencent Cloud Chat voting plugin, please log in first and then initialize.",
      );
    }
  }

  static Future<String> _getCurrentLoginUser() async {
    V2TimValueCallback<String> ruseres = await imManager.getLoginUser();
    return ruseres.data ?? "";
  }

  static bool isVoteMessage(V2TimMessage message) {
    bool isvote = false;
    V2TimCustomElem? custom = message.customElem;

    if (custom != null) {
      String? data = custom.data;
      if (data != null && data.isNotEmpty) {
        try {
          Map<String, dynamic> mapData = json.decode(data);
          if (mapData["businessID"] == "group_poll") {
            isvote = true;
          }
        } catch (err) {
          // err
        }
      }
    }
    return isvote;
  }

  static String getConversationLastMessageInfo(V2TimMessage message) {
    String info = "";
    if (isVoteMessage(message)) {
      info = TIM_t("[投票]");
    }
    return info;
  }
}
